#ifndef __GLOBAL_DEF_H
#define __GLOBAL_DEF_H

// --- ---

// typ HW / desky
//#define ADS_HW_TYPE_A
#define ADS_HW_TYPE_B
// typ procesoru
#define STM32L432xB

// --- ---

// 'ADS_HW_TYPE_A'
#if defined(ADS_HW_TYPE_A)

  // PA1 - DATA-READY!!! (IN) vystup !!!
  // PA2 - SLEEP (OUT) (aktivni v LOW)
  // PA3 - SPI-CS
  // PA5 - SPI CLK
  // PA6 - SPI MISO
  // PA7 - SPI MOSI
  // PA9 - START (OUT)
  // PB1 - RESET (OUT) (aktivni v LOW)
  // PB6 - LED

  // LEDs: Action, Error
  #define LED_ACTION_PORT GPIOB
  #define LED_ACTION_PIN GPIO_PIN_6
  #define LED_ERROR_PORT GPIOB
  #define LED_ERROR_PIN GPIO_PIN_6
  // SPI: CS
  #define SPI_CS_PORT GPIOA
  #define SPI_CS_PIN GPIO_PIN_3
  // ADS: Ready, Sleep, Start, Reset
  #define ADS_READY_PORT GPIOA
  #define ADS_READY_PIN GPIO_PIN_1
  #define ADS_SLEEP_PORT GPIOA
  #define ADS_SLEEP_PIN GPIO_PIN_2
  #define ADS_START_PORT GPIOA
  #define ADS_START_PIN GPIO_PIN_9
  #define ADS_RESET_PORT GPIOB
  #define ADS_RESET_PIN GPIO_PIN_1

  // 'typ' a 'verze' zarizei
  #define INFO_DEVICE_TYPE "A\0x00"
  #define INFO_DEVICE_VER "1.0\0x00"

#endif

// 'ADS_HW_TYPE_B'
#if defined(ADS_HW_TYPE_B)

  // PA1 - DATA-READY!!! (IN) vystup !!!
  // PA2 - SLEEP (OUT) (aktivni v LOW)
  // PA3 - SPI-CS
  // PA5 - SPI CLK
  // PA6 - SPI MISO
  // PA7 - SPI MOSI
  // PB0 - START (OUT)
  // PB1 - RESET (OUT) (aktivni v LOW)
  // PB8 - LED

  // LEDs: Action, Error
  #define LED_ACTION_PORT GPIOA
  #define LED_ACTION_PIN GPIO_PIN_8
  #define LED_ERROR_PORT GPIOA
  #define LED_ERROR_PIN GPIO_PIN_8
  // SPI: CS
  #define SPI_CS_PORT GPIOA
  #define SPI_CS_PIN GPIO_PIN_3
  // ADS: Ready, Sleep, Start, Reset
  #define ADS_READY_PORT GPIOA
  #define ADS_READY_PIN GPIO_PIN_1
  #define ADS_SLEEP_PORT GPIOA
  #define ADS_SLEEP_PIN GPIO_PIN_2
  #define ADS_START_PORT GPIOB
  #define ADS_START_PIN GPIO_PIN_0
  #define ADS_RESET_PORT GPIOB
  #define ADS_RESET_PIN GPIO_PIN_1

  // HW: 'typ', 'verze', 'revize'
  #define INFO_HW_TYPE "B\0x00"
  #define INFO_HW_VER "1\0x00"
  #define INFO_HW_REV "0\0x00"
  // SW: 'typ', 'verze', 'revize'
  #define INFO_SW_TYPE "A\0x00"
  #define INFO_SW_VER "1\0x00"
  #define INFO_SW_REV "0\0x00"
  // SW Uid
  #define INFO_SW_UID { 0x11, 0x22, 0x33, 0x44, 0x55, 0x66, 0x77, 0x88, 0x99, 0xAA }

#endif

#if defined(STM32L432xB)

  //#define STM32_UUID ((uint32_t *)0x1FFF7590)
  #define STM32_UUID_UINT8_PTR ((uint8_t *)0x1FFF7590)

  // velikost bufferu pro data v RAM
  #define USB_BUFFER_SIZE (int)(1024 * 40) // 40kB
  // blok dat prenasenych po USB
  #define USB_SEND_BLOCK 2048

  // adresa v RAM kde se zapisuje typ pro 'Reset'
  #define RESET_FLAGS_RAM_ADR 0x2000FFF0

#endif

// --- nezavisle na konfiguraci HW ---

// 'producent' a 'nazev' zarizeni
#define INFO_DEVICE_PROD "XYZ\0x00"
#define INFO_DEVICE_NAME "Mouse_Head_EEG\0x00"

// pocet bytes vzdy ctenych z ADS
#define MeasureBytes 27

// LEDs time(s)
#define BlickTimeOnOffStartUp 300
#define BlickTimeOnUSBDataStop 100
#define BlickTimeOffUSBDataStop 900
#define BlickTimeOnOffHardFault 200

// nastaveni kompilace pro ladeni
//#define TEST_BY_TIMER       // test mereni pomoci 'timer'
//#define TEST_DATA           // vysilani testovacich dat
//#define TEST_DATA_COUNT     // pocitani vislanych dat
//#define TEST_TIME_TO_SEND   // mereni casu vyslani jednoho paketu / sady dat

// --- ---

#include "stm32l4xx_hal_conf.h"
#include "stm32l4xx_hal.h"
#include "MyApp.h"
#include "XCommun.h"
#include "MyCommun.h"
#include "XSetup.h"
#include "XUtils01.h"

#endif /* __GLOBAL_DEF_H */
