#ifndef X_SETUP_H_
#define X_SETUP_H_

typedef enum _SETUP_FLAGS
{
    SETUP_FLAG_TYPE_8BIT = 0x00,    // 8 bits
    SETUP_FLAG_TYPE_16BIT = 0x01,   // 16 bits
    SETUP_FLAG_TYPE_32BIT = 0x02,   // 32 bits
    SETUP_FLAG_TYPE_64BIT = 0x03,   // 64 bits

    SETUP_FLAG_TYPE_MASK = 0x03,

    // priznak zmeny dat
    SETUP_FLAG_CHANGED = 0x80,
    SETUP_FLAG_CHANGED_MASK = 0x80,
} SETUP_FLAGS;

typedef enum _SETUP_FLAGS_DATA_CHANGED
{
    SETUP_DATA_CHANGED_CLEAR = 0x00,
    SETUP_DATA_CHANGED_SET = 0x01,
} SETUP_FLAGS_DATA_CHANGED;

typedef struct
{
    uint8_t adrHigh;    // vyssi cast virtualni adresy
    uint8_t structSize; // velikost struktury pro ulozeni / nacteni
    void *structData;   // odkaz na instanci
    uint8_t flags;      // priznaky
    uint8_t skipFirst;  // pocet polozek pro preskoceni na zacatku
    uint8_t skipLast;   // pocet polozek pro preskoceni na konce
} SetupConfig;

typedef enum
{
    EnumSetupToReport = 1,
    EnumReportToSetup = 2,
} EnumReportSetupDir;

void SetupToFromReport(uint8_t* reportIn, EnumReportSetupDir reportSetupDir);

// vymazani celeho 'Setup' (vymazani stranek 'Flash')
void SetupClear(void);
// inicializace 'Setup' (vzdy pri spusteni aplikace)
void SetupInit(void);
// nacteni (posledniho) 'Setup' z 'Flash'
void SetupLoad(void *structData);
// ulozeni (aktualniho) 'Setup' do 'Flash'
void SetupStore(void *structData);

//void SetChanged(void *structData, uint8_t flag);

#endif /* X_SETUP_H_ */
